// Copyright (c) 2014 Intel Corporation
// All rights reserved.
//
// WARRANTY DISCLAIMER
//
// THESE MATERIALS ARE PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL INTEL OR ITS
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
// OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THESE
// MATERIALS, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// Intel Corporation is the author of the Materials, and requests that all
// problem reports or change requests be submitted to it directly

#ifndef DIAGNOSTICS_H
#define DIAGNOSTICS_H

// This file defines structures used in both OpenCL kernel code and host
// C code.  It is used to return some diagnostic information from the 
// kernel so it can be displayed using host code.
struct WorkItemInfo
{
    unsigned int global_x;
    unsigned int global_y;
    unsigned int local_size_x;
    unsigned int local_size_y;
    unsigned int enqueued_local_size_x;
    unsigned int enqueued_local_size_y;
};

struct NonUniformDiagnostics
{
    struct WorkItemInfo top_left;
    struct WorkItemInfo top_right;
    struct WorkItemInfo bottom_left;
    struct WorkItemInfo bottom_right;
};

#endif // DIAGNOSTICS_H
